%
% auto-detecting front-end
%
:- module(fastrw,[	fast_read/1,
			fast_read/2,
			fast_write/1,
			fast_write/2,
			fast_buf_read/2,
			fast_buf_write/3
			]).

:- use_module('util/prolog_detect').		%load Prolog detecting module
:- use_module('util/machine_type').		%load platform detecting module
:- use_module('util/flatten').			%load the list flattening module

:-	prolog_detect:prolog(Prolog),			%get Prolog type
	machine_type:get_machine_type(Machine),		%get machine type
	name(Machine,S1),
	name(Prolog,S2),
	name(fastrw,S3),
	flatten([S1,"_",S2,"_",S3],S),			%compose file name string
	name(File,S),
	ensure_loaded(File).				%load file

