:- module(machine_type,[get_machine_type/1]).

%
% return machine type depending on environment variable HOST
%

get_machine_type(Type) :-
	environ('HOST',Hostname),
	host_map(Hostname,Type),
	!.

get_machine_type(Type) :-
	environ('HOSTTYPE',Hosttype),
	hosttype_map(Hosttype,Type),
	!.

get_machine_type(_) :-
	write('*****************************************'),nl,
	write('*** ERROR: Cannot determine host type ***'),nl,
	write('*** Please refer to README and setup  ***'),nl,
	write('*** your HOST or HOSTTYPE variable    ***'),nl,
	write('*****************************************'),nl,
	!,
	fail.

:- ensure_loaded('prolog_detect').

:- ensure_loaded('machine_map').		%load the machine-type database

:- prolog_detect:prolog(Prolog),
	(Prolog=quintus,
	!,
	use_module(library(environ))
	);
	(Prolog=sicstus,
	use_module(library(system))
	).

